/**
 * Lockpick count for the lockpicking minigame with assorted button.
 * @param {string} id Scene id. Used to create controllers.
 * @param {string} key Unique key-space for the lockpicking minigame.
 */
function LockPickingLockPickCount(id, key) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;

    var uniqueIdentifier = arguments.callee.name;
    var elementId = id + "_" + key + "_" + uniqueIdentifier;

    var ctrl = new ChoiceController(id, elementId);

    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    /**
     * Sets the controller's value to how many lockpicks the kobold currently has.
     */
    function setController() {
        ctrl.set(global.kobold.inventory.bag.hasMisc(new Lockpick()));
    }

    // PUBLIC MEMBERS \\        this.public = "test";

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    /**
     * Builds and returns the HTML.
     */
    this.build = function () {
        var lockpick = `<div class="text lockpickcount" id="${elementId}">Lockpicks left: ${ctrl.get()}</div>`;
        return lockpick;
    };

    /**
     * Registers all the required listeners.
     */
    this.registerListeners = function () {

    };

    /**
     * Preloads all assets required, if they have not yet already been loaded.
     */
    this.preload = function () {
        return new Promise(function (resolve, reject) {
            resolve();
        });
    };

    /**
     * Updates the number of lockpicks.
     */
    this.update = function (){
        setController();
        $("#" + elementId).html(`Lockpicks left: ${ctrl.get()}`);
    };

    if (!ctrl.has()) {
        setController();
    }
}
