/**
 * Controller for the Breeding Farm scene.
 * @param {string} sceneId The id of the scene.
 */
function BreedingFarmController(sceneId) {
    // PRIVATE MEMBERS \\       var private = "test";
    var that = this;
    var id = sceneId;

    var autoSaveId = "autoSave";
    var continueId = "continue";


    // PRIVATE FUNCTIONS \\     function privateFunction(){}

    function EagerController(key) {
        ChoiceController.call(this, id, key);

        this.change = function () {
            var changeId = key + "Change";
            global.kobold.history.doIfNotSet(id, changeId, true, function () {
                global.kobold.status.mental.decrease(10, "Caught by Cassidy");
                global.kobold.status.exertion.increase(5, "Loins fondled");
            });
            return global.ui.change.buildNotification([
                new Change("Betrayed", "Sanity", -5),
                new Change("Trapped", "Sanity", -5),
                new Change("Loins fondled", "Sexual exhaustion", +5, true)
            ]);
        };
    }

    function TableController(key) {
        ChoiceController.call(this, id, key);

        this.change = function () {
            var changeId = key + "Change";
            global.kobold.history.doIfNotSet(id, changeId, true, function () {
                global.kobold.status.mental.decrease(15, "Sickened by kobold breeding");
            });
            return global.ui.change.buildNotification([
                new Change("Terrified", "Sanity", -10),
                new Change("Sickened", "Sanity", -5)
            ]);
        };
    }

    function InjectionController(key) {
        ChoiceController.call(this, id, key);

        this.change = function () {
            var changeId = key + "Change";
            global.kobold.history.doIfNotSet(id, changeId, true, function () {
                global.kobold.status.physical.decrease(5, "Injection");
                global.kobold.status.mental.decrease(5, "Injection");
            });
            return global.ui.change.buildNotification([
                new Change("Injection", "Health", -5),
                new Change("Injection", "Sanity", -5)
            ]);
        };
    }

    function TransformationController(key) {
        ChoiceController.call(this, id, key);

        this.change = function () {
            var changeId = key + "Change";
            global.kobold.history.doIfNotSet(id, changeId, true, function () {
                global.kobold.status.mental.decrease(10, "Transformation");
                if (global.kobold.body.dick) {
                    global.kobold.body.growDick(global.kobold.body.dick - 1);
                } else {
                    global.kobold.body.growBreasts(global.kobold.body.breasts + 1);
                }
            });
            return global.ui.change.buildNotification([
                new Change("Transformation", "Sanity", -10)
            ]);
        };
    }

    function BarnResistController(key) {
        ChoiceController.call(this, id, key);

        this.change = function () {
            var changeId = key + "Change";
            global.kobold.history.doIfNotSet(id, changeId, true, function () {
                global.kobold.status.mental.increase(15, "Resisted transformation");
            });
            return global.ui.change.buildNotification([
                new Change("Resisted transformation", "Sanity", +15)
            ]);
        };
    }

    function BarnTableRapeController(key) {
        ChoiceController.call(this, id, key);

        this.change = function () {
            var changeId = key + "Change";
            global.kobold.history.doIfNotSet(id, changeId, true, function () {
                if (global.kobold.body.dick) {
                    global.kobold.body.cockslitVirgin = false;
                } else {
                    global.kobold.body.vaginalVirgin = false;
                }
                global.kobold.status.physical.decrease(5, "Rough sex");
                global.kobold.status.mental.decrease(20, "Raped");
                global.kobold.status.exertion.increase(20, "Raped");
                global.kobold.history.shared.cassidy.tableraped = true;
            });
            return global.ui.change.buildNotification([
                new Change("Rough sex", "Health", -5),
                new Change("Raped", "Sanity", -20),
                new Change("Raped", "Sexual exhaustion", +20, true)
            ]);
        };
    }

    function BarnEscapeController(key) {
        this.change = function () {
            var changeId = key + "Change";
            global.kobold.history.doIfNotSet(id, changeId, true, function () {
                global.kobold.status.mental.increase(10, "Escaped from the barn");
                global.kobold.status.stamina.decrease(25, "Escaped from the barn");
                global.kobold.stats.decreaseStat(StatsEnum.STRENGTH, 1);
            });
            return global.ui.change.buildNotification([
                new Change("Escaped", "Sanity", +10),
                new Change("Escaped", "Stamina", -25),
                new Change("Lasting effects", "Strength", -1),
            ]);
        };
    }

    function UnawareController(key) {
        ChoiceController.call(this, id, key);

        this.change = function () {
            var changeId = key + "Change";
            global.kobold.history.doIfNotSet(id, changeId, true, function () {
                global.kobold.status.mental.increase(10, "Escaped from table");
            });
            return global.ui.change.buildNotification([
                new Change("Escaped table", "Sanity", +10)
            ]);
        };
    }

    function UnawareRunController(key) {
        this.change = function () {
            var changeId = key + "Change";
            global.kobold.history.doIfNotSet(id, changeId, true, function () {
                global.kobold.status.stamina.decrease(25, "Ran from Cassidy");
            });
            return global.ui.change.buildNotification([
                new Change("Ran away", "Stamina", -25)
            ]);
        };
    }

    function UnawareAttackController(key) {
        ChoiceController.call(this, id, key);

        this.change = function (weapon) {
            var changeId = key + "Change";
            if (weapon.stab()) {
                global.kobold.history.doIfNotSet(id, changeId, true, function () {
                    global.kobold.status.mental.decrease(10, "Killed Cassidy");
                });
                return global.ui.change.buildNotification([
                    new Change("Revenge", "Sanity", +10),
                    new Change("Murder", "Sanity", -20)
                ]);
            } else {
                global.kobold.history.doIfNotSet(id, changeId, true, function () {
                    global.kobold.status.mental.increase(10, "Got revenge");
                });
                return global.ui.change.buildNotification([
                    new Change("Revenge", "Sanity", +10)
                ]);
            }
        };
    }

    function UnawareFreeController(key) {
        this.change = function (weapon) {
            var changeId = key + "Change";
            global.kobold.history.doIfNotSet(id, changeId, true, function () {
                global.kobold.status.mental.increase(30, "Kobold saviour");
            });
            return global.ui.change.buildNotification([
                new Change("Unsung hero", "Sanity", +30)
            ]);
        };
    }

    function UnawareLootController(key) {
        ChoiceController.call(this, id, key);

        this.change = function () {
            var changeId = key + "Change";
            if (global.kobold.history.shared.cassidy.dead) {
                global.kobold.history.doIfNotSet(id, changeId, true, function () {
                    global.kobold.inventory.bag.addMisc(new CassidyHouseKey());
                    global.kobold.inventory.bag.addConsumable(new FemPlus());
                });
                return global.ui.change.buildNotification([
                    new Change("Loot", global.kobold.inventory.createItemWithTooltip(new CassidyHouseKey(), true), +1),
                    new Change("Loot", global.kobold.inventory.createItemWithTooltip(new FemPlus(), true), +1)
                ]);
            } else {
                global.kobold.history.doIfNotSet(id, changeId, true, function () {
                    global.kobold.inventory.bag.addConsumable(new FemPlus());
                });
                return global.ui.change.buildNotification([
                    new Change("Loot", global.kobold.inventory.createItemWithTooltip(new FemPlus(), true), +1)
                ]);
            }
        };
    }

    function BarnForceController(key) {
        ChoiceController.call(this, id, key);
        this.change = function () {
            var changeId = key + "Change";
            global.kobold.history.doIfNotSet(id, changeId, true, function () {
                global.kobold.status.physical.decrease(5, "Light scratches");
                global.kobold.status.stamina.decrease(10, "Bear-hugging a vixen");
            });
            return global.ui.change.buildNotification([
                new Change("Scratched by spurs", "Health", -5),
                new Change("Physical exertion", "Stamina", -10)
            ]);
        };
    }

    function BarnForceFreeController(key) {
        this.change = function () {
            var changeId = key + "Change";
            global.kobold.history.doIfNotSet(id, changeId, true, function () {
                global.kobold.status.mental.increase(30, "Kobold saviour");
            });
            return global.ui.change.buildNotification([
                new Change("Unsung hero", "Sanity", +30)
            ]);
        };
    }

    function BarnForceFuckController(key) {
        this.change = function () {
            var changeId = key + "Change";
            global.kobold.history.doIfNotSet(id, changeId, true, function () {
                global.kobold.status.mental.increase(20, "Righteous retribution");
                global.kobold.inventory.bag.addConsumable(new FemPlus());
            });
            return global.ui.change.buildNotification([
                new Change("Righteous retribution", "Sanity", +20),
                new Change("Loot", global.kobold.inventory.createItemWithTooltip(new FemPlus(), true), +1)
            ]);
        };
    }

    // PUBLIC MEMBERS \\        this.public = "test";
    this.varanarSceneName = "NightTwo";
    this.varanarFolderName = "Varanar";

    this.misc = new MiscController(id, "");
    this.arrival = new ChoiceController(id, "arrival");
    this.barn = new ChoiceController(id, "barn");
    this.eager = new EagerController("eager");
    this.table = new TableController("table");
    this.injection = new InjectionController("injection");
    this.transformation = new TransformationController("transformation");
    this.barnResist = new BarnResistController("barnResist");
    this.tableRape = new BarnTableRapeController("barnTableRape");
    this.tiedUp = new ChoiceController(id, "barnTied");
    this.barnEscape = new BarnEscapeController("barnEscape");
    this.unaware = new UnawareController("unaware");
    this.unawareRun = new UnawareRunController("unawareRun");
    this.unawareAttack = new UnawareAttackController("unawareAttack");
    this.unawareLoot = new UnawareLootController("unawareLoot");
    this.unawareFree = new UnawareFreeController("unawareFree");
    this.barnForce = new BarnForceController("barnForce");
    this.barnForceFree = new BarnForceFreeController("barnForceFree");
    this.barnForceFuck = new BarnForceFuckController("barnForceFuck");

    this.tea = new ChoiceController(id, "tea");
    this.notbarn = new ChoiceController(id, "notbarn");
    this.postnotbarn = new ChoiceController(id, "postnotbarn");
    this.postnotbarnsex = new ChoiceController(id, "postnotbarnsex");
    this.notbarnloot = new ChoiceController(id, "notbarnloot");
    this.postnotbarnloot = new ChoiceController(id, "postnotbarnloot");

    // PUBLIC FUNCTIONS \\      this.publicFunction = function(){};

    this.teaDeclineChange = function () {
        var changeId = "teaDeclineChange";
        global.kobold.history.doIfNotSet(id, changeId, true, function () {
            global.kobold.status.mental.decrease(10, "Self-doubt");
        });
        return global.ui.change.buildNotification([
            new Change("Self-doubt", "Sanity", -10)
        ]);
    };

    this.teaDisagreeChange = function () {
        var changeId = "teaDisagreeChange";
        global.kobold.history.doIfNotSet(id, changeId, true, function () {
            global.kobold.status.physical.increase(5, "Drank tea");
        });
        return global.ui.change.buildNotification([
            new Change("Tea", "Health", 5)
        ]);
    };

    this.teaDisagreeContinueChange = function () {
        var changeId = "teaDisagreeContinueChange";
        var int = that.misc.intelligence();
        var cha = that.misc.charisma();
        global.kobold.history.doIfNotSet(id, changeId, true, function () {
            if (int < 6 && cha < 6) {
                global.kobold.status.mental.decrease(20, "Kobolds are pets");
            } else if (int >= 6 && cha < 6) {
                global.kobold.status.mental.decrease(15, "Lost argument");
            } else if (cha >= 6 && int < 6) {
                global.kobold.status.mental.decrease(15, "Kobolds are inferior");
            } else {
                global.kobold.status.mental.increase(10, "Good debate");
            }
        });

        if (int < 6 && cha < 6) {
            return global.ui.change.buildNotification([
                new Change("Realization", "Sanity", -20)
            ]);
        } else if (int >= 6 && cha < 6) {
            return global.ui.change.buildNotification([
                new Change("Realization", "Sanity", -15)
            ]);
        } else if (cha >= 6 && int < 6) {
            return global.ui.change.buildNotification([
                new Change("Realization", "Sanity", -15)
            ]);
        } else {
            return global.ui.change.buildNotification([
                new Change("Held your own", "Sanity", +10)
            ]);
        }
    };

    this.teaAgreeChange = function () {
        var changeId = "teaAgreeChange";
        global.kobold.history.doIfNotSet(id, changeId, true, function () {
            global.kobold.history.shared.cassidy.agree = true;
            global.kobold.status.physical.increase(10, "Tea and biscuits");
            global.kobold.inventory.bag.addConsumable(new TeaBiscuit(), 5);
        });
        return global.ui.change.buildNotification([
            new Change("Tea and biscuits", "Health", 10),
            new Change("Parting gift", global.kobold.inventory.createItemWithTooltip(new TeaBiscuit(), true), 5)
        ]);
    };

    this.teaAgreeContinueChange = function () {
        var changeId = "teaAgreeContinueChange";
        global.kobold.history.doIfNotSet(id, changeId, true, function () {
            global.kobold.status.mental.increase(10, "Made a friend");
        });
        return global.ui.change.buildNotification([
            new Change("Made a friend", "Sanity", 10)
        ]);
    };

    this.notbarnDownstairsLootChange = function () {
        var changeId = "notbarnDownstairsLootChange";
        global.kobold.history.doIfNotSet(id, changeId, true, function () {
            global.kobold.inventory.bag.addMisc(new Silverware());
        });
        return global.ui.change.buildNotification([
            new Change("Stolen goods", global.kobold.inventory.createItemWithTooltip(new Silverware(), true), +1)
        ]);
    };

    this.notbarnUpstairsLootChange = function () {
        var changeId = "notbarnUpstairsLootChange";
        global.kobold.history.doIfNotSet(id, changeId, true, function () {
            global.kobold.status.physical.decrease(5, "Fell down");
            global.kobold.inventory.coins += 43;
        });
        return global.ui.change.buildNotification([
            new Change("Tripped", "Health", -5),
            new Change("Loot", "Coins", +43)
        ]);
    };

    this.notbarnLootContinueChange = function () {
        var changeId = "notbarnLootContinueChange";
        global.kobold.history.doIfNotSet(id, changeId, true, function () {
            global.kobold.status.stamina.decrease(10, "Post-break-in escape");
        });
        return global.ui.change.buildNotification([
            new Change("Running away", "Stamina", -10)
        ]);
    };

    this.notbarnDisagreeChange = function () {
        var changeId = "notbarnDisagreeChange";
        global.kobold.history.doIfNotSet(id, changeId, true, function () {
            global.kobold.history.shared.cassidy.sex = true;
            global.kobold.status.physical.decrease(5, "Thrown to the floor");
        });
        return global.ui.change.buildNotification([
            new Change("Fell down", "Health", -5)
        ]);
    };

    this.notbarnDisagreeSexChange = function () {
        var changeId = "notbarnDisagreeSexChange";
        global.kobold.history.doIfNotSet(id, changeId, true, function () {
            global.kobold.body.oralVirgin = false;
            global.kobold.status.exertion.increase(10, "Vixen facesitting");
        });
        return global.ui.change.buildNotification([
            new Change("Intense oral", "Sexual exhaustion", +10)
        ]);
    };

    this.notbarnDisagreeContinueChange = function () {
        var changeId = "notbarnDisagreeContinueChange";
        global.kobold.history.doIfNotSet(id, changeId, true, function () {
            global.kobold.status.mental.decrease(15, "Forced femdom");
        });
        return global.ui.change.buildNotification([
            new Change("Used for pleasure", "Sanity", -15)
        ]);
    };

    this.notbarnAgreeChange = function () {
        var changeId = "notbarnAgreeChange";
        global.kobold.history.doIfNotSet(id, changeId, true, function () {
            global.kobold.history.shared.cassidy.agree = true;
            global.kobold.history.shared.cassidy.sex = true;
        });
        return "";
    };

    function notbarnAgreeSmallDickSexChange(changeId) {
        global.kobold.history.doIfNotSet(id, changeId, true, function () {
            global.kobold.body.dickVirgin = false;
            global.kobold.status.mental.decrease(15, "Inadequate lover");
            global.kobold.status.stamina.decrease(10, "Fucked Cassidy");
            global.kobold.status.exertion.increase(15, "Fucked Cassidy");
            global.kobold.inventory.bag.addConsumable(new mPlus());
        });
        return global.ui.change.buildNotification([
            new Change("Failed to please", "Sanity", -15),
            new Change("One-sided sex", "Stamina", -10),
            new Change("One-sided sex", "Sexual exhaustion", +15, true),
            new Change("Degrading gift", global.kobold.inventory.createItemWithTooltip(new mPlus(), true), +1)
        ]);
    }
    ;

    function notbarnAgreeMediumDickSexChange(changeId) {
        global.kobold.history.doIfNotSet(id, changeId, true, function () {
            global.kobold.body.dickVirgin = false;
            global.kobold.status.mental.increase(10, "Pleased the bitch");
            global.kobold.status.stamina.decrease(15, "Fucked Cassidy");
            global.kobold.status.exertion.increase(20, "Fucked Cassidy");
        });
        return global.ui.change.buildNotification([
            new Change("Pleased Cassidy", "Sanity", +10),
            new Change("Pleasant fuck", "Stamina", -15),
            new Change("Pleasant fuck", "Sexual exhaustion", +20, true)
        ]);
    }
    ;

    function notbarnAgreeBigDickSexChange(changeId) {
        global.kobold.history.doIfNotSet(id, changeId, true, function () {
            global.kobold.body.dickVirgin = false;
            global.kobold.status.mental.increase(15, "Broke the bitch");
            global.kobold.status.stamina.decrease(20, "Demolished Cassidy");
            global.kobold.status.exertion.increase(25, "Demolished Cassidy");
        });
        return global.ui.change.buildNotification([
            new Change("Broke the bitch", "Sanity", +15, ),
            new Change("Intense sex", "Stamina", -20),
            new Change("Intense sex", "Sexual exhaustion", +25, true)
        ]);
    }
    ;

    function notbarnAgreeFemaleSexChange(changeId) {
        global.kobold.history.doIfNotSet(id, changeId, true, function () {
            global.kobold.status.exertion.increase(20, "Eaten out");
        });
        return global.ui.change.buildNotification([
            new Change("Eaten out", "Sexual exhaustion", +20, true)
        ]);
    }
    ;

    this.notbarnAgreeSexChange = function (dick) {
        var changeId = "notbarnAgreeSexChange";
        if (!dick) {
            return notbarnAgreeFemaleSexChange(changeId);
        }
        if (dick < SizeEnum.AVERAGE) {
            return notbarnAgreeSmallDickSexChange(changeId);
        }
        if (dick < SizeEnum.LARGER) {
            return notbarnAgreeMediumDickSexChange(changeId);
        }
        return notbarnAgreeBigDickSexChange(changeId);
    };

    this.minigame;

    this.createMinigame = function () {
        that.minigame = new LockPickingMinigame(id, "breakinMinigame", 10, 2);
    };

    /*
     * Autosaves the game if necessary.
     */
    this.autosave = function () {
        global.kobold.history.doIfNotSet(id, autoSaveId, true, function () {
            global.saveManager.autoSave();
        });
    };

    /**
     * Signals the scene has been continued.
     */
    this.continue = function () {
        global.kobold.history.setKey(id, continueId, true);
    };

    /**
     * Returns whether or not the scene has continued.
     * @returns {boolean} True if the scene has continued, false otherwise.
     */
    this.continued = function () {
        return global.kobold.history.has(id, continueId);
    };
}

